Package: daemon
Version: 0.6.3-1
Priority: wishlist
Tags: patch

I've used daemon to provide an init.d script for a server program (xorp) that
could not fork by itself and also generated all output on stdout/stderr (so
start-stop-daemon was not good here).

Attached is a template init.d script for daemon I've derived from the one
I've written. I think this template could be useful for other's that wish to
do the same and prevent them from making the same mistakes I made when
trying to get it work.

The patch introduces the init.d script in the debian/ subdir and will install
it through dh_installexamples. It is heavily commented so it should be pretty
straightforward and easy to understand. It includes most features you've come
to expect from init.d scripts these days:

- LSB headers
- support for /etc/default/
- LSB output messages
- 'status' check (notice there's too ways to do it in the script, that's
  because daemon's --running option will not work for non-root users if the
  process was started by root)
- proper check of all actions to tell the user what really happened
  (some init.d scripts just claim to have started a server when the
  server died as soon as it started :)

Hope you like it. Please include it in the package, thanks


Javier
diff -Nru daemon-0.6.3/debian/daemon.initd daemon-0.6.3.initd/debian/daemon.initd
--- daemon-0.6.3/debian/daemon.initd	1970-01-01 01:00:00.000000000 +0100
+++ daemon-0.6.3.initd/debian/daemon.initd	2007-08-25 18:36:01.000000000 +0200
@@ -0,0 +1,293 @@
+#!/bin/sh 
+#
+# Example template for the use of the 'daemon' wrapper for
+# server software. Please read the template carefully
+# and modify the sections to adjust it to the program you
+# want to run.
+#
+# Copyright (c) 2007 Javier Fernandez-Sanguino <[EMAIL PROTECTED]>
+#
+# This is free software; you may redistribute it and/or modify
+# it under the terms of the GNU General Public License as
+# published by the Free Software Foundation; either version 2,
+# or (at your option) any later version.
+#
+# This is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License with
+# the Debian operating system, in /usr/share/common-licenses/GPL;  if
+# not, write to the Free Software Foundation, Inc., 59 Temple Place,
+# Suite 330, Boston, MA 02111-1307 USA
+#
+### BEGIN INIT INFO
+# Provides:          <short name>
+# Required-Start:    $network $local_fs
+# Required-Stop:     
+# Should-Start:      $named
+# Should-Stop:       
+# Default-Start:     2 3 4 5
+# Default-Stop:      0 1 6
+# Short-Description: <Enter a short description of the sortware>
+# Description:       <Enter a long description of the software>
+#                    <...>
+#                    <...>
+### END INIT INFO
+
+PATH=/sbin:/bin:/usr/sbin:/usr/bin
+DAEMON_WRAPPER=/usr/bin/daemon
+
+# CONFIGURE THIS:
+DAEMON=SERVER_LOCATION_PATH         # Introduce the server's location here
+NAME=SERVER_NAME                    # Introduce the short server's name here
+DESC="SOME DESCRIPTION"             # Introduce a short description here
+LOGDIR=/var/log/server              # Log directory to use
+
+PIDFILE=/var/run/$NAME.pid 
+
+test -x $DAEMON || exit 0
+test -x $DAEMON_WRAPPER || exit 0
+
+. /lib/lsb/init-functions
+
+# Default options, these can be overriden by the information
+# at /etc/default/$NAME
+RUN="no"                # Do not run the Server, useful when
+                        # it cannot work out of the box and needs 
+                        # configuration after installatino
+
+SERVER_OPTS=""          # Additional options given to the server 
+
+DAEMON_OPTS=""          # Additional options given to the daemon program
+                        # (for example: chroot, chuid...). Only used
+                        # when starting up
+
+DIETIME=10              # Time to wait for the server to die, in seconds
+                        # If this value is set too low you might not
+                        # let some servers to die gracefully and
+                        # 'restart' will not work
+                        
+LOGFILE=$LOGDIR/$NAME.log          # Logfile where the program's stdout
+                                   # is captured
+LOGFILE_ERR=$LOGDIR/$NAME.err.log  # Logfile where the program's stderr
+                                   # is captured
+
+# Include defaults if available
+if [ -f /etc/default/$NAME ] ; then
+	. /etc/default/$NAME
+fi
+
+if [ "x$RUN" != "xyes" ] ; then
+    log_failure_msg "$NAME disabled, please adjust the configuration to your needs "
+    log_failure_msg "and then set RUN to 'yes' in /etc/default/$NAME to enable it."
+    exit 1
+fi
+
+set -e
+
+running_pid()
+{
+# Check if a given process pid's cmdline matches a given name
+    pid=$1
+    name=$2
+    [ -z "$pid" ] && return 1 
+    [ ! -d /proc/$pid ] &&  return 1
+    cmd=`cat /proc/$pid/cmdline | tr "\000" "\n"|head -n 1 |cut -d : -f 1`
+    # Is this the expected child?
+    [ "$cmd" != "$name" ] &&  return 1
+    return 0
+}
+
+running_proc()
+{
+# Check if the process is running looking at /proc
+# (works for all users)
+
+    # No pidfile, probably no daemon present
+    [ ! -f "$PIDFILE" ] && return 1
+    pid=`cat $PIDFILE`
+
+    running_pid $pid $DAEMON_WRAPPER || return 1
+    
+    # The daemon exists, check also that the parent process (the wrapper) has a
+    # child which is $DAEMON
+    pidchild=`ps -eo ppid,pid |grep ^$pid | awk '{print $2}'| head -1`
+    running_pid $pidchild $DAEMON || return 1
+
+    return 0
+}
+
+running_daemon()
+{
+# Check if the process is running using 'daemon'
+# (only works for root)
+        $DAEMON_WRAPPER --running --pidfile $PIDFILE \
+            --name=$NAME 
+        return $?
+}
+
+running()
+{
+# Check if the process is running
+# Use one function or other depending if we are root or not
+    if [ "`id -u`" != "0" ] ; then
+        running_proc
+        return $?
+    fi
+    running_daemon
+    return  $?
+}
+
+start_server() {
+# Start the process using the wrapper
+        $DAEMON_WRAPPER $DAEMON_OPTS --pidfile $PIDFILE \
+            --name=$NAME \
+            --stdout=$LOGFILE \
+            --stderr=$LOGFILE_ERR \
+            -- $DAEMON  $SERVER_OPTS
+        errcode=$?
+	return $errcode
+}
+
+stop_server () {
+# Stop the process using the wrapper
+        $DAEMON_WRAPPER --stop --pidfile $PIDFILE \
+            --name=$NAME \
+        errcode=$
+	return $errcode
+}
+
+reload_server () {
+    [ ! -f "$PIDFILE" ] && return 1
+    pid=`cat $PIDFILE` # This is the daemon's pid
+    # Obtain the server's process pid:
+    pidchild=`ps -eo ppid,pid |grep ^$pid | awk '{print $2}'| head -1`
+    # Send a SIGHUP
+    kill -1 $pidchlid
+    return $?
+}
+
+force_stop() {
+# Force the process to die killing it manually
+	[ ! -e "$PIDFILE" ] && return
+	if running ; then
+		kill -15 $pid
+	# Is it really dead?
+		sleep "$DIETIME"s
+		if running ; then
+			kill -9 $pid
+			sleep "$DIETIME"s
+			if running ; then
+				echo "Cannot kill $NAME (pid=$pid)!"
+				exit 1
+			fi
+		fi
+	fi
+	rm -f $PIDFILE
+}
+
+
+case "$1" in
+  start)
+	log_daemon_msg "Starting $DESC " "$NAME"
+        # Check if it's running first
+        if running ;  then
+            log_progress_msg "apparently already running"
+            log_end_msg 0
+            exit 0
+        fi
+        if start_server && running ;  then
+            # It's ok, the server started and is running
+            log_end_msg 0
+        else
+            # Either we could not start it or it is not running
+            # after we did
+            # NOTE: Some servers might die some time after they start,
+            # this code does not try to detect this and might give
+            # a false positive (use 'status' for that)
+            log_end_msg 1
+        fi
+	;;
+  stop)
+        log_daemon_msg "Stopping $DESC" "$NAME"
+        if running ; then
+            # Only stop the server if we see it running
+            stop_server
+            log_end_msg $?
+        else
+            # If it's not running don't do anything
+            log_progress_msg "apparently not running"
+            log_end_msg 0
+            exit 0
+        fi
+        ;;
+  force-stop)
+        # First try to stop gracefully the program
+        $0 stop
+        if running; then
+            # If it's still running try to kill it more forcefully
+            log_daemon_msg "Stopping (force) $DESC" "$NAME"
+            force_stop
+            log_end_msg $?
+        fi
+	;;
+  restart|force-reload)
+        log_daemon_msg "Restarting $DESC" "$NAME"
+        stop_xorp
+        # Wait some sensible amount, some server need this
+        [ -n "$DIETIME" ] && sleep $DIETIME
+        start_xorp
+        running
+        log_end_msg $?
+	;;
+  status)
+        log_daemon_msg "Checking status of $DESC" "$NAME"
+        if running ;  then
+            log_progress_msg "running"
+            log_end_msg 0
+        else
+            log_progress_msg "apparently not running"
+            log_end_msg 1
+            exit 1
+        fi
+        ;;
+  # Use this if the daemon cannot reload
+  reload)
+        log_warning_msg "Reloading $NAME daemon: not implemented, as the daemon"
+        log_warning_msg "cannot re-read the config file (use restart)."
+        ;;
+  # And this if it cann
+  #reload)
+          #
+          # If the daemon can reload its config files on the fly
+          # for example by sending it SIGHUP, do it here.
+          #
+          # If the daemon responds to changes in its config file
+          # directly anyway, make this a do-nothing entry.
+          #
+          # log_daemon_msg "Reloading $DESC configuration files" "$NAME"
+          # if running ; then
+          #    reload_server
+          #    if ! running ;  then
+          # Process died after we tried to reload
+          #       log_progress_msg "died on reload"
+          #       log_end_msg 1
+          #       exit 1
+          #    fi
+          # else
+          #    log_progress_msg "server is not running"
+          #    log_end_msg 1
+          #    exit 1
+          # fi
+                                                                                    #;;
+
+  *)
+	N=/etc/init.d/$NAME
+	echo "Usage: $N {start|stop|restart|force-reload|status}" >&2
+	exit 1
+	;;
+esac
+
+exit 0
diff -Nru daemon-0.6.3/debian/rules daemon-0.6.3.initd/debian/rules
--- daemon-0.6.3/debian/rules	2007-08-25 18:28:27.000000000 +0200
+++ daemon-0.6.3.initd/debian/rules	2007-08-25 18:28:16.000000000 +0200
@@ -69,7 +69,7 @@
 	dh_testroot
 #	dh_installdebconf
 	dh_installdocs
-#	dh_installexamples
+	dh_installexamples debian/daemon.initd
 #	dh_installmenu
 #	dh_installlogrotate
 #	dh_installemacsen

Attachment: signature.asc
Description: Digital signature

Reply via email to